#include <iostream>
#include <vector>
#include "histogram.h"

using namespace std;

const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

struct 
Input {
    vector<double> numbers;
    int bin_count{};
};

Input 
input_data(){
    size_t number_count;
    cin >> number_count;
    Input in;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }
    int bin_count;
    cin >> in.bin_count;
    return in;
}

void
show_histogramm_text(vector<int> bins, vector<double> numbers, size_t bin_count){

    size_t max_count;
    for (int i =0; i<bin_count;i++){
        if (numbers[i]>max_count){
            max_count=numbers[i];
        }
    }
   

    for (int i =0; i<bin_count;i++){
        if (bins[i]>max_count){
            max_count=bins[i];
        }
    }

    if (max_count>MAX_ASTERISK){
        for (int i=0; i<bin_count; i++){
            size_t height = MAX_ASTERISK * (static_cast<double>(bins[i]) / max_count);
            if (bins[i]<10){
                cout<<"  "<<bins[i]<<"|";
                for (int j=0;j<bins[i];j++){
                    cout<<"*";
                }
                cout<<endl;
            }
            else if(bins[i]<100){
               cout<<" "<<bins[i]<<"|";
                for (int j=0;j<bins[i];j++){
                    cout<<"*";
                }
                cout<<endl;
            }
            else{
                cout<<bins[i]<<"|";
                for (int j=0;j<bins[i];j++){
                    cout<<"*";
                }
                cout<<endl;
            }

        }
    }else{
        for (int i=0; i<bin_count; i++){
            if (bins[i]<10){
                cout<<"  "<<bins[i]<<"|";
                for (int j=0;j<bins[i];j++){
                    cout<<"*";
                }
                cout<<endl;
            }
            else if(bins[i]<100){
               cout<<" "<<bins[i]<<"|";
                for (int j=0;j<bins[i];j++){
                    cout<<"*";
                }
                cout<<endl;
            }
            else{
                cout<<bins[i]<<"|";
                for (int j=0;j<bins[i];j++){
                    cout<<"*";
                }
                cout<<endl;
            }

        }
    }
}


int 
main()
{
    
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogramm_text(bins, in.numbers, in.bin_count);
}
 
   